Imports EdgeJs
Imports System.Threading.Tasks
Imports System.Web.Mvc
Imports TodoMVC.Models

Namespace TodoMVC.Controllers
	Public Class HomeController
		Inherits Controller

        Private Shared render As Func(Of Object, Task(Of Object)) = Edge.Func(
            "			var app = require('../../Scripts/app.js');" & ControlChars.CrLf &
            "			var ReactDOMServer = require('react-dom/server');" & ControlChars.CrLf &
            "			var Navigation = require('navigation');" & ControlChars.CrLf &
            "        " & ControlChars.CrLf &
            "			return function (data, callback) {" & ControlChars.CrLf &
            "			  Navigation.StateController.navigateLink(data.Url);" & ControlChars.CrLf &
            "			  var filter = Navigation.StateContext.data.filter;" & ControlChars.CrLf &
            "			  var list = app.getList(data.Todos, filter);" & ControlChars.CrLf &
            "			  callback(null, ReactDOMServer.renderToString(list));" & ControlChars.CrLf &
            "			}" & ControlChars.CrLf &
            "		")
        Public Async Function Index() As Task(Of ActionResult)
            Dim todos As List(Of Todo) = New TodoRepository().Todos.ToList()
            Dim data = New With {Key .Url = Request.Url.PathAndQuery, Key .Todos = todos}
            Dim test As String = CStr(Await render(data))
            'ViewBag.List = CStr(Await render(data))
            'ViewBag.Todos = todos
            Return View()
        End Function
	End Class
End Namespace
